script passed through shellcheck linter
[bash-notes.git] / notes.sh
old mode 100644 (file)
new mode 100755 (executable)
index fa54bae..04141e6
--- a/notes.sh
+++ b/notes.sh
@@ -1,16 +1,34 @@
 #! /bin/bash
 
-# set -ex
+# bash-notes © 2023 by danix is licensed under CC BY-NC 4.0. 
+# To view a copy of this license, visit http://creativecommons.org/licenses/by-nc/4.0/
+
+# to debug the script run it like:
+# DEBUG=true notes.sh ...
+# and check /tmp/debug_bash-notes.log
+if [[ $DEBUG == true ]]; then
+       exec 5> /tmp/debug_bash-notes.log
+       BASH_XTRACEFD="5"
+       PS4='$LINENO: '
+       set -x
+fi
 
 PID=$$
-VERSION="0.1"
+VERSION="0.2"
 
 set_defaults() {
 # Binaries to use
+JQ=${JQ:-/usr/bin/jq}
 EDITOR=${EDITOR:-/usr/bin/vim}
 TERMINAL=${TERMINAL:-/usr/bin/alacritty}
-JQ=${JQ:-/usr/bin/jq}
+# add options for your terminal. Remember to add the last option to execute
+# your editor program, otherwise the script will fail.
+# see example in the addnote function
+TERM_OPTS="--class notes --title notes -e "
 
+# set this to true to have output in plain text
+# or use the -p option on the command line before every other option
+PLAIN=false
 # base directory for program files
 BASEDIR=${BASEDIR:-~/.local/share/bash-notes}
 # notes database in json format
@@ -25,10 +43,10 @@ set_defaults
 # Do not edit below this point
 RCFILE=${RCFILE:-~/.config/bash-notes.rc}
 TMPDB=/tmp/db.json
-BASENAME=$( basename $0 )
+BASENAME=$( basename "$0" )
 NOW=$(date +%s)
 
-if [ ! -x $JQ ]; then
+if [ ! -x "$JQ" ]; then
        echo "jq not found in your PATH"
        echo "install jq to continue"
        exit 1
@@ -36,11 +54,12 @@ fi
 
 # IMPORT USER DEFINED OPTIONS IF ANY
 if [[ -f $RCFILE ]]; then
-       source $RCFILE
+       # shellcheck disable=SC1090
+       source "$RCFILE"
 fi
 
 # We prevent the program from running more than one instance:
-PIDFILE=/var/tmp/$(basename $0 .sh).pid
+PIDFILE=/var/tmp/$(basename "$0" .sh).pid
 
 # Make sure the PID file is removed when we kill the process
 trap 'rm -f $PIDFILE; exit 1' TERM INT
@@ -48,13 +67,27 @@ trap 'rm -f $PIDFILE; exit 1' TERM INT
 if [[ -r $PIDFILE ]]; then
        # PIDFILE exists, so I guess there's already an instance running
        # let's kill it and run again
+       # shellcheck disable=SC2046,SC2086
        kill -s 15 $(cat $PIDFILE) > /dev/null 2>&1
        # should already be deleted by trap, but just to be sure
-       rm $PIDFILE
+       rm "$PIDFILE"
 fi
 
 # create PIDFILE
-echo $PID > $PIDFILE
+echo $PID > "$PIDFILE"
+
+# check if input is a number, returns false or the number itself
+function check_noteID() {
+       IN=$1
+       case $IN in
+               ''|*[!0-9]*)
+                       return 1
+                       ;;
+               *)
+                       echo "$IN"
+                       ;;
+       esac
+}
 
 function helptext() {
     echo "Usage:"
@@ -67,6 +100,7 @@ base directory:              ${BASEDIR}/
 notes archive:         ${NOTESDIR}/
 notes database:                ${DB}
 rc file:               $RCFILE
+debug file:            /tmp/debug_bash-note.log
 
 text editor:           ${EDITOR}
 terminal:              ${TERMINAL}
@@ -74,65 +108,141 @@ jq executable:            ${JQ}
 __NOWCONF__
 
        echo ""
-    echo "The script's parameters are:"
+    echo "${BASENAME} parameters are:"
     echo "  -h | --help                        : This help text"
     echo "  -p | --plain                       : Output is in plain text"
-    echo "                               (without this option the output is colored)"
+    echo "                               (without this option the output is formatted)"
+    echo "                               (this option must precede all others)"
     echo "  -l | --list                        : List existing notes"
-    echo "  -a | --add <title>         : Add new note"
-    echo "  -m | --modify <note>               : Modify note"
-    echo "  -d | -date <note>          : Modify date for note"
-    echo "  -r | --remove <note>               : Remove note"
+    echo "  -a | --add [\"<title>\"]   : Add new note"
+    echo "  -e | --edit [<note>]               : Edit note"
+    echo "  -d | --delete [<note> | all]       : Delete single note or all notes at once"
     echo "  -v | --version             : Print version"
     echo "  --userconf                 : Export User config file"
+    echo ""
 }
 
 function addnote() {
+       # remove eventually existing temp DB file
+       if [[ -f $TMPDB ]]; then
+               rm $TMPDB
+       fi
+
        NOTETITLE="$1"
        echo "adding new note - \"$NOTETITLE\""
-       LASTID=$($JQ '.notes[-1].id | tonumber' $DB)
-       [ null == $LASTID ] && LASTID=0
-       NOTEID=$(( $LASTID + 1 ))
+       # shellcheck disable=SC2086
+       LASTID=$($JQ '.notes[-1].id // 0 | tonumber' $DB)
+       # [ "" == $LASTID ] && LASTID=0
+       NOTEID=$(( LASTID + 1 ))
+       # shellcheck disable=SC2086
        touch ${NOTESDIR}/${NOW}
+       # shellcheck disable=SC2016
        $JQ --arg i "$NOTEID" --arg t "$NOTETITLE" --arg f "$NOW" '.notes += [{"id": $i, "title": $t, "file": $f}]' "$DB" > $TMPDB
+       # shellcheck disable=SC2086
        mv $TMPDB $DB
-       $(${TERMINAL} --class notes --title notes -e ${EDITOR} ${NOTESDIR}/${NOW})
+       # example for alacritty:
+       # alacritty --class notes --title notes -e /usr/bin/vim ...
+       # shellcheck disable=SC2086,SC2091
+       $(${TERMINAL} ${TERM_OPTS} ${EDITOR} ${NOTESDIR}/${NOW})
 }
 
 function listnotes() {
-       echo "listing all notes"
-       [ $PLAIN == true ] && echo "output is plain text" || echo "output is colored"
-       echo ""
-       echo "[ID]      [TITLE]"
-       for i in ${NOTESDIR}/*; do
-               TITLE=$($JQ -r --arg z $(basename $i) '.notes[] | select(.file == $z) | .title' $DB)
-               ID=$($JQ -r --arg z $(basename $i) '.notes[] | select(.file == $z) | .id' $DB)
-
-               echo "[${ID}]   ${TITLE}"
-       done
+       # [ $PLAIN == true ] && echo "output is plain text" || echo "output is colored"
+       if [[ $(ls -A "$NOTESDIR") ]]; then
+               if [ $PLAIN == false ]; then
+                       echo "listing all notes"
+                       echo ""
+               fi
+               [ $PLAIN == false ] && echo "[ID]       [TITLE]         [CREATED]"
+               for i in "${NOTESDIR}"/*; do
+                       # shellcheck disable=SC2155
+                       local fname=$(basename $i)
+                       DATE=$(date -d @${fname} +"%d/%m/%Y %R %z%Z")
+                       # shellcheck disable=SC2016,SC2086
+                       TITLE=$($JQ -r --arg z $(basename $i) '.notes[] | select(.file == $z) | .title' $DB)
+                       # shellcheck disable=SC2016,SC2086
+                       ID=$($JQ -r --arg z $(basename $i) '.notes[] | select(.file == $z) | .id' $DB)
+                       [ $PLAIN == false ] && echo "[${ID}]    ${TITLE}        ${DATE}" || echo "${ID} - ${TITLE} - ${DATE}"
+               done
+       else
+               echo "no notes yet. You can add your first one with: ${BASENAME} -a \"your note title\""
+       fi
 }
 
 function editnote() {
-       TITLE=$($JQ --arg i $1 '.notes[] | select(.id == $i) | .title' $DB)
-       FILE=$($JQ -r --arg i $1 '.notes[] | select(.id == $i) | .file' $DB)
+       NOTE=$1
+       # shellcheck disable=SC2155
+       local OK=$(check_noteID "$NOTE")
+       if [ ! "$OK" ]; then
+               echo "invalid note \"$NOTE\""
+               echo "Use the note ID that you can fetch after listing your notes"
+               exit 1
+       fi
+
+       # shellcheck disable=SC2016,SC2086
+       TITLE=$($JQ --arg i $OK '.notes[] | select(.id == $i) | .title' $DB)
+       # shellcheck disable=SC2016,SC2086
+       FILE=$($JQ -r --arg i $OK '.notes[] | select(.id == $i) | .file' $DB)
        if [ "$TITLE" ]; then
                echo "editing note $TITLE"
-               $(${TERMINAL} --class notes --title notes -e ${EDITOR} ${NOTESDIR}/${FILE})
+               # shellcheck disable=SC2086,SC2091
+               $(${TERMINAL} ${TERM_OPTS} ${EDITOR} ${NOTESDIR}/${FILE})
        else
                 echo "note not found"
                 exit 1
        fi
 }
 
-function datenote() {
-       echo "edit date for note \"${1}\""
-       # FILEDATE=$(date -d @$NOW +%d/%m/%Y_%T)
-
-}
-
 function rmnote() {
+       # remove eventually existing temp DB file
+       if [[ -f $TMPDB ]]; then
+               rm $TMPDB
+       fi
+
        NOTE=$1
-       echo "removing note $NOTE"
+       if [ "all" == "$NOTE" ]; then
+               echo "You're going to delete all notes."
+               read -r -p "Do you wish to continue? (y/N) " ANSWER
+               case $ANSWER in
+                       y|Y )
+                               # shellcheck disable=SC2086
+                               $JQ 'del(.notes[])' $DB > $TMPDB
+                               # shellcheck disable=SC2086
+                               mv $TMPDB $DB
+                               # shellcheck disable=SC2086
+                               rm $NOTESDIR/*
+                               echo "Deleted all notes"
+                               ;;
+                       * )
+                               echo "Aborting, no notes were deleted."
+                               exit 1
+                               ;;
+               esac
+       else
+               # shellcheck disable=SC2155
+               local OK=$(check_noteID "$NOTE")
+               if [ ! "$OK" ]; then
+                       echo "invalid note \"$NOTE\""
+                       echo "Use the note ID that you can fetch after listing your notes"
+                       exit 1
+               fi
+
+               # shellcheck disable=SC2016,SC2086
+               TITLE=$($JQ --arg i $OK '.notes[] | select(.id == $i) | .title' $DB)
+               # shellcheck disable=SC2016,SC2086
+               FILE=$($JQ -r --arg i $OK '.notes[] | select(.id == $i) | .file' $DB)
+               if [ "$TITLE" ]; then
+               # shellcheck disable=SC2016,SC2086
+               $JQ -r --arg i $OK 'del(.notes[] | select(.id == $i))' $DB > $TMPDB
+               # shellcheck disable=SC2086
+               mv $TMPDB $DB
+               rm $NOTESDIR/$FILE
+               echo "Deleted note $TITLE"
+               else
+                        echo "note not found"
+                        exit 1
+               fi
+       fi
 }
 
 function export_config() {
@@ -201,16 +311,16 @@ fi
 
 # NOTE: This requires GNU getopt.  On Mac OS X and FreeBSD, you have to install this
 # separately; see below.
-GOPT=`getopt -o hvpla:m:d:r: --long help,version,list,plain,userconf,add:,modify:,date:,remove:,editor:,storage: \
+# shellcheck disable=SC2006
+GOPT=`getopt -o hvpla:e:d: --long help,version,list,plain,userconf,add:,edit:,delete:,editor:,storage: \
              -n 'bash-notes' -- "$@"`
 
-if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi
+# shellcheck disable=SC2181
+if [ $? != 0 ] ; then helptext >&2 ; exit 1 ; fi
 
 # Note the quotes around `$GOPT': they are essential!
 eval set -- "$GOPT"
 
-PLAIN=false
-
 while true; do
        case "$1" in
                -h | --help )
@@ -234,28 +344,26 @@ while true; do
                        shift 2
                        addnote "$TITLE"
                ;;
-               -m | --modify )
+               -e | --edit )
                        NOTE="$2"
                        shift 2
                        editnote "$NOTE"
                        ;;
-               -d | --date )
-                       NOTE="$2"
-                       shift 2
-                       datenote "$NOTE"
-                       ;;
-               -r | --remove )
+               -d | --delete )
                        NOTE="$2"
                        shift 2
                        rmnote "$NOTE"
                        ;;
                --userconf )
                        export_config
+                       # shellcheck disable=SC2317
                        echo "config exported to \"$RCFILE\""
+                       # shellcheck disable=SC2317
                        exit
                        ;;
                -- )
-                       shift; break
+                       shift
+                       break
                        ;;
                * )
                        break